Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Types.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Types.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Types.h	(revision 88)
@@ -0,0 +1,184 @@
+#ifndef morpheo_behavioural_core_multi_ooo_engine_ooo_engine_commit_unit_Types_h
+#define morpheo_behavioural_core_multi_ooo_engine_ooo_engine_commit_unit_Types_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Types.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace commit_unit {
+
+  typedef enum
+    {
+      RETIRE_IN_ORDER       ,
+      RETIRE_OOO_RENAME_UNIT,
+      RETIRE_OOO_CONTEXT
+    } retire_ooo_t;
+
+  typedef enum
+    {
+      ROB_EMPTY                     , // 
+      ROB_BRANCH_WAIT_END           , // 
+      ROB_BRANCH_COMPLETE           , // 
+      ROB_STORE_WAIT_HEAD_OK        , // 
+//    ROB_STORE_WAIT_HEAD_KO        , // 
+      ROB_STORE_HEAD_OK             , // 
+      ROB_STORE_HEAD_KO             , // 
+      ROB_OTHER_WAIT_END            , // 
+      ROB_MISS_WAIT_END             , // 
+      ROB_END_OK_SPECULATIVE        , // 
+      ROB_END_OK                    , // 
+      ROB_END_KO_SPECULATIVE        , // 
+      ROB_END_KO                    , // 
+      ROB_END_MISS                  , // 
+      ROB_END_EXCEPTION_WAIT_HEAD   , // 
+      ROB_END_EXCEPTION               // 
+    } rob_state_t;
+
+  class entry_t 
+  {
+  public  : rob_state_t        state                   ;
+  public  : uint32_t           ptr                     ;
+  public  : Tcontext_t         front_end_id            ;
+  public  : Tcontext_t         context_id              ;
+  public  : uint32_t           rename_unit_id          ;
+  public  : Tdepth_t           depth                   ;
+  public  : Ttype_t            type                    ;
+  public  : Toperation_t       operation               ;
+  public  : Tcontrol_t         is_delay_slot           ;
+  public  : Tgeneral_data_t    address                 ;
+  public  : Tcontrol_t         use_store_queue         ;
+  public  : Tcontrol_t         use_load_queue          ;
+  public  : Tlsq_ptr_t         store_queue_ptr_write   ;
+  public  : Tlsq_ptr_t         load_queue_ptr_write    ;
+  public  : Tcontrol_t         read_ra                 ;
+  public  : Tgeneral_address_t num_reg_ra_log          ;
+  public  : Tgeneral_address_t num_reg_ra_phy          ;
+  public  : Tcontrol_t         read_rb                 ;
+  public  : Tgeneral_address_t num_reg_rb_log          ;
+  public  : Tgeneral_address_t num_reg_rb_phy          ;
+  public  : Tcontrol_t         read_rc                 ;
+  public  : Tspecial_address_t num_reg_rc_log          ;
+  public  : Tspecial_address_t num_reg_rc_phy          ;
+  public  : Tcontrol_t         write_rd                ;
+  public  : Tgeneral_address_t num_reg_rd_log          ;
+  public  : Tgeneral_address_t num_reg_rd_phy_old      ;
+  public  : Tgeneral_address_t num_reg_rd_phy_new      ;
+  public  : Tcontrol_t         write_re                ;
+  public  : Tspecial_address_t num_reg_re_log          ;
+  public  : Tspecial_address_t num_reg_re_phy_old      ;
+  public  : Tspecial_address_t num_reg_re_phy_new      ;
+
+  public  : Tevent_state_t     event_state             ;
+  public  : Texception_t       exception               ;
+  public  : Texception_t       exception_use           ;
+
+  public  : Tspecial_data_t    flags                   ;
+  public  : Tcontrol_t         no_sequence             ;
+  public  : Tgeneral_data_t    data_commit             ; // branch's destination
+
+//   public  : entry_t (uint32_t           ptr                     ,
+// 		     Tcontext_t         front_end_id            ,
+// 		     Tcontext_t         context_id              ,
+// 		     Tcontext_t         rename_unit_id          ,
+// 		     Tdepth_t           depth                   ,
+// 		     Ttype_t            type                    ,
+// 		     Toperation_t       operation               ,
+// 		     Tcontrol_t         is_delay_slot           ,
+// 		     Tgeneral_data_t    address                 ,
+// 		     Texception_t       exception               ,
+// 		     Texception_t       exception_use           ,
+// 		     Tlsq_ptr_t         store_queue_ptr_write   ,
+// 		     Tlsq_ptr_t         load_queue_ptr_write    ,
+// 		     Tcontrol_t         read_ra                 ,
+// 		     Tgeneral_address_t num_reg_ra_log          ,
+// 		     Tgeneral_address_t num_reg_ra_phy          ,
+// 		     Tcontrol_t         read_rb                 ,
+// 		     Tgeneral_address_t num_reg_rb_log          ,
+// 		     Tgeneral_address_t num_reg_rb_phy          ,
+// 		     Tcontrol_t         read_rc                 ,
+// 		     Tspecial_address_t num_reg_rc_log          ,
+// 		     Tspecial_address_t num_reg_rc_phy          ,
+// 		     Tcontrol_t         write_rd                ,
+// 		     Tgeneral_address_t num_reg_rd_log          ,
+// 		     Tgeneral_address_t num_reg_rd_phy_old      ,
+// 		     Tgeneral_address_t num_reg_rd_phy_new      ,
+// 		     Tcontrol_t         write_re                ,
+// 		     Tspecial_address_t num_reg_re_log          ,
+// 		     Tspecial_address_t num_reg_re_phy_old      ,
+// 		     Tspecial_address_t num_reg_re_phy_new      )
+//     {
+//       this->ptr                     = ptr                   ;
+//       this->front_end_id            = front_end_id          ;
+//       this->context_id              = context_id            ;
+//       this->rename_unit_id          = rename_unit_id        ;
+//       this->depth                   = depth                 ;
+//       this->type                    = type                  ;
+//       this->operation               = operation             ;
+//       this->is_delay_slot           = is_delay_slot         ;
+//       this->address                 = address               ;
+//       this->exception               = exception             ;
+//       this->exception_use           = exception_use         ;
+//       this->store_queue_ptr_write   = store_queue_ptr_write ;
+//       this->load_queue_ptr_write    = load_queue_ptr_write  ;
+//       this->read_ra                 = read_ra               ;
+//       this->num_reg_ra_log          = num_reg_ra_log        ;
+//       this->num_reg_ra_phy          = num_reg_ra_phy        ;
+//       this->read_rb                 = read_rb               ;
+//       this->num_reg_rb_log          = num_reg_rb_log        ;
+//       this->num_reg_rb_phy          = num_reg_rb_phy        ;
+//       this->read_rc                 = read_rc               ;
+//       this->num_reg_rc_log          = num_reg_rc_log        ;
+//       this->num_reg_rc_phy          = num_reg_rc_phy        ;
+//       this->write_rd                = write_rd              ;
+//       this->num_reg_rd_log          = num_reg_rd_log        ;
+//       this->num_reg_rd_phy_old      = num_reg_rd_phy_old    ;
+//       this->num_reg_rd_phy_new      = num_reg_rd_phy_new    ;
+//       this->write_re                = write_re              ;
+//       this->num_reg_re_log          = num_reg_re_log        ;
+//       this->num_reg_re_phy_old      = num_reg_re_phy_old    ;
+//       this->num_reg_re_phy_new      = num_reg_re_phy_new    ;
+//     }
+  };
+
+}; // end namespace commit_unit
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+}; // end namespace behavioural
+
+ template<> inline std::string toString<morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::rob_state_t>(const morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::rob_state_t& x)
+  {
+    switch (x)
+      {
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_EMPTY                     : return "empty"                     ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_BRANCH_WAIT_END           : return "branch_wait_end"           ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_BRANCH_COMPLETE           : return "branch_complete"           ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_STORE_WAIT_HEAD_OK        : return "store_wait_head_ok"        ; break;
+//    case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_STORE_WAIT_HEAD_KO        : return "store_wait_head_ko"        ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_STORE_HEAD_OK             : return "store_head_ok"             ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_STORE_HEAD_KO             : return "store_head_ko"             ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_OTHER_WAIT_END            : return "other_wait_end"            ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_MISS_WAIT_END             : return "miss_wait_end"             ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_END_OK_SPECULATIVE        : return "end_ok_speculative"        ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_END_OK                    : return "end_ok"                    ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_END_KO_SPECULATIVE        : return "end_ko_speculative"        ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_END_KO                    : return "end_ko"                    ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_END_EXCEPTION_WAIT_HEAD   : return "end_exception_wait_head"   ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::ROB_END_EXCEPTION             : return "end_exception"             ; break;
+      default    : return ""      ; break;
+      }
+  };
+
+}; // end namespace morpheo              
+
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit.cpp	(revision 88)
@@ -0,0 +1,290 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Commit_unit.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace commit_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Commit_unit::Commit_unit"
+  Commit_unit::Commit_unit 
+  (
+#ifdef SYSTEMC
+   sc_module_name name,
+#else
+   string name,
+#endif
+#ifdef STATISTICS
+   morpheo::behavioural::Parameters_Statistics * param_statistics,
+#endif
+   morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::Parameters * param,
+   morpheo::behavioural::Tusage_t usage
+   ):
+    _name              (name)
+    ,_param            (param)
+    ,_usage            (usage)
+  {
+    log_begin(Commit_unit,FUNCTION);
+
+    usage_environment(_usage);
+
+#if DEBUG_Commit_unit == true
+    log_printf(TRACE,Commit_unit,FUNCTION,_("<%s> Parameters"),_name.c_str());
+
+    std::cout << *param << std::endl;
+#endif
+
+    log_printf(INFO,Commit_unit,FUNCTION,_("<%s> Allocation"),_name.c_str());
+
+    allocation (
+#ifdef STATISTICS
+		param_statistics
+#endif
+		);
+
+#ifdef STATISTICS
+    if (usage_is_set(_usage,USE_STATISTICS))
+      {	
+	log_printf(INFO,Commit_unit,FUNCTION,_("<%s> Allocation of statistics"),_name.c_str());
+
+	statistics_allocation(param_statistics);
+      }
+#endif
+
+#ifdef VHDL
+    if (usage_is_set(_usage,USE_VHDL))
+      {
+	// generate the vhdl
+	log_printf(INFO,Commit_unit,FUNCTION,_("<%s> Generate the vhdl"),_name.c_str());
+	
+	vhdl();
+      }
+#endif
+
+#ifdef SYSTEMC
+    if (usage_is_set(_usage,USE_SYSTEMC))
+      {
+        // Constant
+	for (uint32_t i=0; i<_param->_nb_front_end; i++)
+	  for (uint32_t j=0; j<_param->_nb_context [i]; j++)
+	    {
+              internal_EVENT_ACK [i][j] = 1;
+              PORT_WRITE(out_EVENT_ACK [i][j], internal_EVENT_ACK [i][j]);
+            }
+
+	log_printf(INFO,Commit_unit,FUNCTION,_("<%s> Method - transition"),_name.c_str());
+
+	SC_METHOD (transition);
+	dont_initialize ();
+	sensitive << (*(in_CLOCK)).pos();
+	
+# ifdef SYSTEMCASS_SPECIFIC
+	// List dependency information
+# endif    
+
+	log_printf(INFO,Commit_unit,FUNCTION,_("<%s> Method - genMoore"),_name.c_str());
+
+	SC_METHOD (genMoore);
+	dont_initialize ();
+	sensitive << (*(in_CLOCK)).neg(); // need internal register
+	
+# ifdef SYSTEMCASS_SPECIFIC
+	// List dependency information
+# endif    
+
+	log_printf(INFO,Commit_unit,FUNCTION,_("<%s> Method - genMealy_insert"),_name.c_str());
+
+	SC_METHOD (genMealy_insert);
+	dont_initialize ();
+	sensitive << (*(in_CLOCK)).neg(); // need internal register
+// 	for (uint32_t i=0; i<_param->_nb_rename_unit; i++)
+// 	  for (uint32_t j=0; j<_param->_nb_inst_insert[i]; j++)
+// 	    sensitive << (*(in_INSERT_VAL [i][j]));
+
+# ifdef SYSTEMCASS_SPECIFIC
+	// List dependency information
+	for (uint32_t i=0; i<_param->_nb_rename_unit; i++)
+	  for (uint32_t j=0; j<_param->_nb_inst_insert[i]; j++)
+	    for (uint32_t x=0; x<_param->_nb_rename_unit; x++)
+	      for (uint32_t y=0; y<_param->_nb_inst_insert[x]; y++)
+		{
+		  (*(out_INSERT_ACK       [i][j])) (*(in_INSERT_VAL [x][y]));
+		  if (_param->_have_port_rob_ptr)
+		  (*(out_INSERT_PACKET_ID [i][j])) (*(in_INSERT_VAL [x][y]));
+		}
+# endif    
+
+	log_printf(INFO,Commit_unit,FUNCTION,_("<%s> Method - genMealy_retire"),_name.c_str());
+
+	SC_METHOD (genMealy_retire);
+	dont_initialize ();
+	sensitive << (*(in_CLOCK)).neg(); // need internal register
+	for (uint32_t i=0; i<_param->_nb_rename_unit; i++)
+	  for (uint32_t j=0; j<_param->_nb_inst_retire[i]; j++)
+	    sensitive << (*(in_RETIRE_ACK [i][j]));
+
+	for (uint32_t i=0; i<_param->_nb_front_end; ++i)
+	  for (uint32_t j=0; j<_param->_nb_context[i]; ++j)
+	    sensitive << (*(in_SPR_WRITE_ACK [i][j]));
+
+# ifdef SYSTEMCASS_SPECIFIC
+	// List dependency information
+	for (uint32_t i=0; i<_param->_nb_rename_unit; i++)
+	  for (uint32_t j=0; j<_param->_nb_inst_retire[i]; j++)
+	    {
+	      for (uint32_t x=0; x<_param->_nb_rename_unit; x++)
+		for (uint32_t y=0; y<_param->_nb_inst_retire[x]; y++)
+		  {
+		    (*(out_RETIRE_VAL                   [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    if (_param->_have_port_front_end_id)
+		    (*(out_RETIRE_FRONT_END_ID          [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    if (_param->_have_port_context_id)
+		    (*(out_RETIRE_CONTEXT_ID            [i][j])) (*(in_RETIRE_ACK [x][y]));
+// 		    (*(out_RETIRE_RENAME_UNIT_ID        [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    (*(out_RETIRE_EVENT_STATE           [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    (*(out_RETIRE_USE_STORE_QUEUE       [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    (*(out_RETIRE_USE_LOAD_QUEUE        [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    (*(out_RETIRE_STORE_QUEUE_PTR_WRITE [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    if (_param->_have_port_load_queue_ptr)
+		    (*(out_RETIRE_LOAD_QUEUE_PTR_WRITE  [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    (*(out_RETIRE_READ_RA               [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    (*(out_RETIRE_NUM_REG_RA_PHY        [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    (*(out_RETIRE_READ_RB               [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    (*(out_RETIRE_NUM_REG_RB_PHY        [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    (*(out_RETIRE_READ_RC               [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    (*(out_RETIRE_NUM_REG_RC_PHY        [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    (*(out_RETIRE_WRITE_RD              [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    (*(out_RETIRE_NUM_REG_RD_LOG        [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    (*(out_RETIRE_NUM_REG_RD_PHY_OLD    [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    (*(out_RETIRE_NUM_REG_RD_PHY_NEW    [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    (*(out_RETIRE_WRITE_RE              [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    (*(out_RETIRE_NUM_REG_RE_LOG        [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    (*(out_RETIRE_NUM_REG_RE_PHY_OLD    [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    (*(out_RETIRE_NUM_REG_RE_PHY_NEW    [i][j])) (*(in_RETIRE_ACK [x][y]));
+		  }
+
+	      for (uint32_t x=0; x<_param->_nb_front_end; ++x)
+		for (uint32_t y=0; y<_param->_nb_context[x]; ++y)
+		  {
+		    (*(out_RETIRE_VAL                   [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    if (_param->_have_port_front_end_id)
+		    (*(out_RETIRE_FRONT_END_ID          [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    if (_param->_have_port_context_id)
+		    (*(out_RETIRE_CONTEXT_ID            [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+// 		    (*(out_RETIRE_RENAME_UNIT_ID        [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    (*(out_RETIRE_EVENT_STATE           [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    (*(out_RETIRE_USE_STORE_QUEUE       [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    (*(out_RETIRE_USE_LOAD_QUEUE        [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    (*(out_RETIRE_STORE_QUEUE_PTR_WRITE [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    if (_param->_have_port_load_queue_ptr)
+		    (*(out_RETIRE_LOAD_QUEUE_PTR_WRITE  [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    (*(out_RETIRE_READ_RA               [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    (*(out_RETIRE_NUM_REG_RA_PHY        [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    (*(out_RETIRE_READ_RB               [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    (*(out_RETIRE_NUM_REG_RB_PHY        [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    (*(out_RETIRE_READ_RC               [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    (*(out_RETIRE_NUM_REG_RC_PHY        [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    (*(out_RETIRE_WRITE_RD              [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    (*(out_RETIRE_NUM_REG_RD_LOG        [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    (*(out_RETIRE_NUM_REG_RD_PHY_OLD    [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    (*(out_RETIRE_NUM_REG_RD_PHY_NEW    [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    (*(out_RETIRE_WRITE_RE              [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    (*(out_RETIRE_NUM_REG_RE_LOG        [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    (*(out_RETIRE_NUM_REG_RE_PHY_OLD    [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    (*(out_RETIRE_NUM_REG_RE_PHY_NEW    [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		  }
+	    }
+
+	for (uint32_t i=0; i<_param->_nb_front_end; ++i)
+	  for (uint32_t j=0; j<_param->_nb_context[i]; ++j)
+	    {
+	      for (uint32_t x=0; x<_param->_nb_rename_unit; x++)
+		for (uint32_t y=0; y<_param->_nb_inst_retire[x]; y++)
+		  {
+		    (*(out_SPR_WRITE_VAL       [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    (*(out_SPR_WRITE_SR_F_VAL  [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    (*(out_SPR_WRITE_SR_F      [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    (*(out_SPR_WRITE_SR_CY_VAL [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    (*(out_SPR_WRITE_SR_CY     [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    (*(out_SPR_WRITE_SR_OV_VAL [i][j])) (*(in_RETIRE_ACK [x][y]));
+		    (*(out_SPR_WRITE_SR_OV     [i][j])) (*(in_RETIRE_ACK [x][y]));
+		  }
+
+	      for (uint32_t x=0; x<_param->_nb_front_end; ++x)
+		for (uint32_t y=0; y<_param->_nb_context[x]; ++y)
+		  {
+		    (*(out_SPR_WRITE_VAL       [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    (*(out_SPR_WRITE_SR_F_VAL  [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    (*(out_SPR_WRITE_SR_F      [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    (*(out_SPR_WRITE_SR_CY_VAL [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    (*(out_SPR_WRITE_SR_CY     [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    (*(out_SPR_WRITE_SR_OV_VAL [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		    (*(out_SPR_WRITE_SR_OV     [i][j])) (*(in_SPR_WRITE_ACK [x][y]));
+		  }
+	    }
+# endif    
+
+	log_printf(INFO,Commit_unit,FUNCTION,_("<%s> Method - genMealy_commit"),_name.c_str());
+
+	SC_METHOD (genMealy_commit);
+	dont_initialize ();
+	sensitive << (*(in_CLOCK)).neg(); // need internal register
+        for (uint32_t j=0; j<_param->_nb_inst_commit; j++)
+          {
+            sensitive << (*(in_COMMIT_VAL [j]));
+            if (_param->_have_port_rob_ptr)
+              sensitive << (*(in_COMMIT_PACKET_ID [j]));
+          }
+
+# ifdef SYSTEMCASS_SPECIFIC
+	// List dependency information
+        for (uint32_t j=0; j<_param->_nb_inst_commit; j++)
+          for (uint32_t y=0; y<_param->_nb_inst_commit; y++)
+            {
+              (*(out_COMMIT_ACK [j])) (*(in_COMMIT_VAL       [y]));
+              if (_param->_have_port_rob_ptr)
+                (*(out_COMMIT_ACK [j])) (*(in_COMMIT_PACKET_ID [y]));
+            }
+# endif    
+	
+#endif
+      }
+    log_end(Commit_unit,FUNCTION);
+  };
+    
+#undef  FUNCTION
+#define FUNCTION "Commit_unit::~Commit_unit"
+  Commit_unit::~Commit_unit (void)
+  {
+    log_begin(Commit_unit,FUNCTION);
+
+#ifdef STATISTICS
+    if (usage_is_set(_usage,USE_STATISTICS))
+      {
+	statistics_deallocation();
+      }
+#endif
+
+    log_printf(INFO,Commit_unit,FUNCTION,_("<%s> Deallocation"),_name.c_str());
+    deallocation ();
+
+    log_end(Commit_unit,FUNCTION);
+  };
+
+}; // end namespace commit_unit
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
